********************************************************************
* CoVDG - VDG Console Output Subroutine for VTIO
*
* $Id$
*
* Edt/Rev  YYYY/MM/DD  Modified by
* Comment
* ------------------------------------------------------------------
*   1      ????/??/??
* From Tandy OS-9 Level One VR 02.00.00
*
*          2003/09/22  Rodney Hamilton
* recoded dispatch table fcbs, fixed cursor color bug

         nam   CoVDG
         ttl   VDG Console Output Subroutine for VTIO

BASEADDR	equ   $FF78

NTSC        equ     $00
PAL         equ     $80
VIDFREQ     equ     PAL
OSCAN	    equ     $03			*overscanned characters on the left
LASTC       equ     75			*last visible column (0-79). Change required also in TERM and VTIO	



RESET		EQU		$06
TOSADD		EQU		$08
CURLO		EQU		$09
CURHI		EQU		$0A
FILADD		EQU		$0B
ATTDAT		EQU		$0C
CHARACTER	EQU		$0D
MODREG		EQU		$0E

VMODE		EQU		$01
CURSON		EQU		$00
CURSOFF		EQU		$40

V.WpX		EQU		V.C80X
V.WpY		EQU		V.C80Y
V.TOSAdd	EQU		V.ColPtr
V.LinAdd	EQU		V.Co80X


* Disassembled 98/08/23 17:47:40 by Disasm v1.6 (C) 1988 by RML

         ifp1
         use   defsfile
         use   cocovtio.d
         endc

tylg     set   Systm+Objct
atrv     set   ReEnt+rev
rev      set   $00
edition  set   1

         mod   eom,name,tylg,atrv,start,size

u0000    rmb   0
size     equ   .
         fcb   $07

name     fcs   /CoWP/
         fcb   edition

start    equ   *
         lbra  Init
         lbra  Write
         lbra  GetStat
         lbra  SetStat
Term     pshs  y,x
*         pshs  u		save U
*         ldd   #512		32x16 VDG memory size
*         ldu   <V.ScrnA,u 	get pointer to memory
*         os9   F$SRtMem 	return to system
*         puls  u		restore U
         ldb   <V.COLoad,u
         andb  #~ModCoWP
         bra   L0086
* Init
Init     pshs  y,x		save regs

		ldx   #BASEADDR
		ldd		#RESET*256
		sta		1,x
		stb		,x		reset

		ldd		#ATTDAT*256+VMODE+CURSON
		lbsr	WriteReg

		ldd		#TOSADD*256+VIDFREQ
		lbsr	WriteReg

        sta   <V.CChar,u 	put character under the cursor
        sta   <V.Chr1,u	only referenced here ??
	 clr   <V.Caps,u        lowercase
        lbsr  ClrScrn		clear the screen
        ldb   <V.COLoad,u
        orb   #ModCoVDG	set to CoVDG found (?)
L0086    stb   <V.COLoad,u
         clrb
         puls  pc,y,x

* GetStat
GetStat  ldx   PD.RGS,y		get caller's regs
         cmpa  #SS.Cursr	Cursr?
         beq   Rt.Cursr		branch if so
* SetStat
SetStat  comb
         ldb   #E$UnkSvc
         rts

* SS.Cursr getstat
Rt.Cursr clra
         ldb   <V.WpY,u
         addb  #$20
         std   R$Y,x
         ldb   <V.WpX,u
         addb  #$20
         std   R$X,x
		 pshs x
         ldx   #BASEADDR
         lda   #CHARACTER
         sta   1,x
         lbsr  WaitBUSY
         lda   ,x
		 anda	#$7f
		 puls	x
         sta   R$A,x
* no operation entry point

NoOp     clrb
         rts

* Write
Write    ldx   #BASEADDR	get HW addr in X
         ldb   V.51EscSeq,u
         bne   L0165     
         cmpa  #$1B            CoHR Escape Code?
	   beq   CoESC
         cmpa  #$0E		$0E?
         bcs   L00B6		branch if less than
         cmpa  #$1E		$1E?
         bcs   NoOp		branch if less than
         cmpa  #C$SPAC		space?
         lbcs  Check1F		branch if less than
         cmpa  #$7F		$7F?
         lbcs   ChrOut		ASCII char, branch if less than
         cmpa  #$C0		$C0?
         bls   L00A6		branch if lower or same
         anda  #$1F
         suba  #$01
         cmpa  #$19
         bhi   L00B2
         lbra   ChrOut
L00A6    cmpa  #$AA		$AA?
         bcs   L00B2		branch if less than
         ora   #$10
         anda  #$1F
         cmpa  #$1A
         bcc   ChrOut
L00B2    lda   #$7F
         bra   ChrOut

L00B6    leax  >FuncTbl,pcr
         lsla
         ldd   a,x
         leax  d,x
         pshs  x
         ldx   #BASEADDR
STOP     rts

*1B Escape - 
CoESC
         inc   V.51EscSeq,u * flag ESC seq
	  clrb
	  rts

L0148    tst   ,y        
         bne   L0150

CancelEscSequence
	  clr   V.51EscSeq,u 
	  clrb
WriteExit
	  rts   
InESC    
L0150    cmpa  ,y+       
         bne   L0161     
         ldd   ,y        
         leay  >CtrlCharDispatch,pcr
         leay  d,y       
         sty   V.51CtrlDispatch,u
         jsr   ,y        
         bra   WriteExit 
                         
L0161    leay  $02,y     
         bra   L0148     
                         
L0165    inc   V.51EscSeq,u
         leay  >EscCharDispatch,pcr
         cmpb  #$01      
         beq   L0148  
*should probably never reach this point?   
         jmp   [V.51CtrlDispatch,u]




* $08 - cursor left
CurLft   ldd   <V.WpX,u	get CO80 X/Y
         bne   L00E8		branch if not at start
         clrb
         rts
L00E8    deca
	 cmpa  #OSCAN
         bge   L00EE
         lda   #LASTC
         decb
L00EE    std   <V.WpX,u
         bra   L014F

* $09 - cursor up
DoCursorUp
CurUp    ldb   <V.WpY,u
         beq   CancelEscSequence
         decb
         stb   <V.WpY,u
         lbra  L01CC

* $0D - move cursor to start of line (carriage return)
CrRtn    
*clr   <V.WpX,u
	 lda   #OSCAN            move to OSCAN offset 
	 sta   <V.WpX,u
         bra   L014C

* ChrOut - output a readable character
* Entry: A = ASCII value of character to output
ChrOut   ora   <V.Invers,u	add inverse video flag
         pshs  a		save char
         ldb   #CHARACTER
         stb   1,x
         bsr   WaitBUSY		wait for HW
         puls  a		restore char
         sta   ,x		write character

* $06 - cursor right
DoCursorRight
CurRgt   inc   <V.WpX,u
         lda   <V.WpX,u
         cmpa  #LASTC
         ble   L014C
         bsr   CrRtn

* $0A - cursor down (line feed)
DoLineFeed
CurDown
	 ldb   <V.WpY,u
         cmpb  #23
         bge   L012E
         incb
         stb   <V.WpY,u
         bra   L014F

L012E	 ldd   <V.LinAdd,u
         addd  #80
         bsr   WrapAdd
         std   <V.LinAdd,u
	     lbsr  L01DC
	     lbsr  ErEOL

		 ldd   <V.TOSAdd,u
		 addd	#80
		 std	<V.TOSAdd,u
		 cmpd	#2000
		 bmi   ScrDn
		 ldd	#0
		 std	<V.TOSAdd,u
ScrDn	 lbsr	L016B
		 lda	#TOSADD
		 orb    #VIDFREQ
		 lbsr	WriteReg
L014C    ldb   <V.WpY,u
L014F    lbra  L01CC

* $01 - home cursor
CurHome  clr   <V.WpY,u
	   lda   #OSCAN
         sta   <V.WpX,u
         ldd   <V.TOSAdd,u
		 std   <V.LinAdd,u
         lbra  L01DC

WrapAdd  cmpd  #2000
         bcs   L016A
         addd	#48
	 anda	#$07
L016A    rts

L016B    lsra
         rorb
         lsra
         rorb
         lsra
         rorb
         lsra
         rorb
         rts

* X = address of WordPak
WaitBUSY lda   1,x
         bpl   WaitBUSY
         rts

WriteReg sta   1,x
	 stb   ,x
	 lbra CancelEscSequence


* $03 - erase line
ErLine  lbsr    CrRtn		do a CR
DoClrEOL
ErEOL   ldy     #80
        ldd     #MODREG*256|128
        bsr     WriteReg
        lda	    #CHARACTER
	sta	    1,x
@loop	lbsr	WaitBusy
	lda	    #32
	ora	    <V.Invers,u
	sta	    ,x
        leay    -1,y
        bne     @loop
        ldd     #MODREG*256
        bra     WriteReg


* $0C - clear screen
ClrScrn  ldd   #0
		 std   <V.TOSAdd,u
		 bsr   CurHome		do home cursor, then erase to EOS
		 ldd   #0
		 lbsr  ScrDn

* $0B - erase to end of screen
DoClearEOS
ErEOS    ldd	<V.TOSAdd,u
L0189	 bsr	L016B
		 lda	#FILADD
		 andb	#$7F
		 bsr	WriteReg
		 lda	#CHARACTER
		 sta	1,x
		 lbsr	WaitBusy
		 lda	#32
		 ora	<V.Invers,u
		 sta	,x
L01A0    lbra CancelEscSequence




*
* $1b41xxyy - move cursor to col xx (0-50) row yy (0-23)
*
DoGotoXY 
* $02 XX YY - move cursor to col XX-32, row YY-32
CurXY    leax  >L01B0,pcr
         ldb   #$02
L01A8    stx   <V.RTAdd,u
         stb   <V.NGChr,u
         clrb
         rts
L01B0    ldx   #BASEADDR	get HW address
	 clr   V.CColr,u        there 
	 lda   V.51EscSeq,u
	 bne   Nosubt
         lda   #32		*subtract 32-OSCAN 
         sta  V.CColr,u          *temp use of the Flag Cursor variable - not used here
Nosubt 
         lda   <V.NChar,u	and char1 in A
         ldb   <V.NChr2,u	get char2 in B
         suba  V.CColr,u		subtract 32 from A
         adda  #OSCAN
         blt   L01A0		if less than 0, we're done
         cmpa  #LASTC		compare against greatest column
         bgt   L01A0		branch if >79
         subb  V.CColr,u		else subtract 32 from B
         blt   L01A0		if less than 0, we're done
         cmpb  #23		compare against greatest row
         bgt   L01A0		branch if >23
         std   <V.WpX,u	else store A/B in new col/row position
L01CC    
	 lda   #80		multiply A*80 to find new row
         mul
         addd  <V.TOSAdd,u
         lbsr   WrapAdd
	 std   <V.LinAdd,u
         addb  <V.WpX,u
         adca  #$00
         lbsr   WrapAdd

L01DC    pshs  a,b
         lda   #CURHI
         ldb   ,s+
   	 andb	#$07
	 lbsr	WriteReg

         lda   #CURLO
         ldb   ,s+
         lbsr   WriteReg
	 lbra    CancelEscSequence

	   

Check1F  cmpa  #$1F
         bne   WritErr
         lda   <V.NChr2,u
         cmpa  #$21
         beq   InvOn
         cmpa  #$20
         beq   InvOff
WritErr  comb
         ldb   #E$Write
         rts




* $05 XX - set cursor off/on/color per XX-32
CurOnOff leax  >L0219,pcr
         ldb   #$01
         bra   L01A8
L0219    ldx   #BASEADDR
         lda   <V.NChr2,u	get next character
         cmpa  #$20		cursor code valid?
         blt   WritErr		no, error
         beq   L022D
         cmpa  #$21		color code in range?
         bgt   L020F		no, ignore
CurOn    ldb   #VMODE+CURSON
         bra   L022F
L022D    ldb   #VMODE+CURSOFF
L022F    lda   #ATTDAT
         lbsr	WriteReg
         clrb
         rts
DoUnderlineOn
DoReverseOn
InvOn    lda   #$80
         sta   <V.Invers,u
	 lbra    CancelEscSequence

DoUnderlineOff
DoReverseOff
InvOff   clr   <V.Invers,u
L020F    
	 lbra    CancelEscSequence


* display functions dispatch table
CtrlCharDispatch
FuncTbl  fdb   NoOp-FuncTbl	$00:no-op (null)
         fdb   CurHome-FuncTbl	$01:HOME cursor
         fdb   CurXY-FuncTbl	$02:CURSOR XY
         fdb   ErLine-FuncTbl	$03:ERASE LINE
         fdb   ErEOL-FuncTbl	$04:ERASE TO EOL
         fdb   CurOnOff-FuncTbl	$05:CURSOR ON/OFF
         fdb   CurRgt-FuncTbl	$06:CURSOR RIGHT
         fdb   NoOp-FuncTbl	$07:no-op (bel:handled in VTIO)
         fdb   CurLft-FuncTbl	$08:CURSOR LEFT
         fdb   CurUp-FuncTbl	$09:CURSOR UP
         fdb   CurDown-FuncTbl	$0A:CURSOR DOWN
         fdb   ErEOS-FuncTbl	$0B:ERASE TO EOS
         fdb   ClrScrn-FuncTbl	$0C:CLEAR SCREEN
         fdb   CrRtn-FuncTbl	$0D:RETURN

* escape sequences dispatch table
EscCharDispatch                 
         fcb   $41        * cursor xy
         fdb   DoGotoXY-CtrlCharDispatch * $FDCB
         fcb   $42        * clear EOL
         fdb   DoClrEOL-CtrlCharDispatch * $FD41
         fcb   $43        * cursor right
         fdb   DoCursorRight-CtrlCharDispatch * $FDEE
         fcb   $44        * cursor up
         fdb   DoCursorUp-CtrlCharDispatch * $FC2D
         fcb   $45        * cursor down
         fdb   DoLineFeed-CtrlCharDispatch * $FC3E         fcb   $46        * reverse on
         fdb   DoReverseOn-CtrlCharDispatch * $FDFE
         fcb   $47        * reverse off
         fdb   DoReverseOff-CtrlCharDispatch * $FE07
         fcb   $48        * underline on
         fdb   DoUnderlineOn-CtrlCharDispatch * $FE0B
         fcb   $49        * underline off
         fdb   DoUnderlineOff-CtrlCharDispatch * $FE13
         fcb   $4A        * clear EOS
         fdb   DoClearEOS-CtrlCharDispatch * $FDA5
         fcb   $00       

         emod
eom      equ   *
         end

